#ifndef RegionIncluded
#define RegionIncluded

#include "config.h"

typedef struct {
	//size of the region in codels (for push command)
	int size;
	//color of the region (0-19)
	int color;
	//exitpoints[DC/CC][x/y-value]: exit point inside the region
	//idea: each white codel gets an own region entry, containing the leftmost, rightmost, upmost and downmost pixel in straight.
	//then: if the codel next to the exitpoint is black the next codel should be searched using the new region at the exit point.
	//all visited points (coordinates and the CC/DP) have to be stored. if a visited point is reached again with same CC/DP the program terminates.
	//size of black and white regions doesn't matter.
	int exitpoints[8][2];
	// stores for each exit-direction if the asm code has been generated yet.
	bool asm_generated[8];
	// id of the region for label in asm code.
	unsigned int id;
} Region;

#endif
